# BlumBlumShub Class Reference

`#include <blumshub.h>`

Inheritance diagram for BlumBlumShub:

List of all members.

## Detailed Description

BlumBlumShub with factorization of the modulus.

Definition at line 36 of file blumshub.h.

## Public Member Functions
| BlumBlumShub (const Integer &p, const Integer &q, const Integer &seed)
bool | IsRandomAccess () const
| returns whether this cipher supports random access
void | Seek (lword index)
| for random access ciphers, seek to an absolute position
unsigned int | GenerateBit ()
| generate new random bit and return it
byte | GenerateByte ()
| generate new random byte and return it
void | GenerateBlock (byte *output, size_t size)
| generate random array of bytes
void | ProcessData (byte *outString, const byte *inString, size_t length)
| encrypt or decrypt an array of bytes of specified length
bool | IsSelfInverting () const
| returns whether this transformation is self-inverting (e.g. xor with a keystream)
bool | IsForwardTransformation () const
| returns whether this is an encryption object
virtual void | IncorporateEntropy (const byte *input, size_t length)
| update RNG state with additional unpredictable values
virtual bool | CanIncorporateEntropy () const
| returns true if IncorporateEntropy is implemented
virtual word32 | GenerateWord32 (word32 a=0, word32 b=0xffffffffL)
| generate a random 32 bit word in the range min to max, inclusive
virtual void | DiscardBytes (size_t n)
| generate and discard n bytes
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| generate random bytes as input to a BufferedTransformation
template<class IT>
void | Shuffle (IT begin, IT end)
| randomly shuffle the specified array, resulting permutation is uniformly distributed
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
StreamTransformation & | Ref ()
| return a reference to this object,
virtual unsigned int | MandatoryBlockSize () const
| returns block size, if input must be processed in blocks, otherwise 1
virtual unsigned int | OptimalBlockSize () const
| returns the input block size that is most efficient for this cipher
virtual unsigned int | GetOptimalBlockSizeUsed () const
| returns how much of the current block is used up
virtual unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| for ciphers where the last block of data is special, encrypt or decrypt the last block of data
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| same as ProcessData(inoutString, inoutString, length)
void | ProcessString (byte *outString, const byte *inString, size_t length)
| same as ProcessData(outString, inString, length)
byte | ProcessByte (byte input)
| implemented as {ProcessData(&input, &input, 1); return input;}
## Protected Attributes
const Integer | p
const Integer | q
const Integer | x0
ModularArithmetic | modn
word | maxBits
word | bitsLeft
Integer | current
## Friends
class | BlumGoldwasserPublicKey
class | BlumGoldwasserPrivateKey

## Member Function Documentation

unsigned int PublicBlumBlumShub::GenerateBit | ( |  | ) | `[virtual, inherited]`

generate new random bit and return it

Default implementation is to call GenerateByte() and return its lowest bit.

Reimplemented from RandomNumberGenerator.

Definition at line 16 of file blumshub.cpp.

References Integer::GetBit(), and ModularArithmetic::Square().

Referenced by PublicBlumBlumShub::GenerateByte().

void PublicBlumBlumShub::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length |
| ) |  |  | `[virtual, inherited]`

encrypt or decrypt an array of bytes of specified length

Note:
  either inString == outString, or they don't overlap

Implements StreamTransformation.

Definition at line 41 of file blumshub.cpp.

References PublicBlumBlumShub::GenerateByte().

StreamTransformation& StreamTransformation::Ref | ( |  | ) | `[inline, inherited]`

return a reference to this object,

This function is useful for passing a temporary StreamTransformation object to a function that takes a non-const reference.

Definition at line 483 of file cryptlib.h.

virtual unsigned int StreamTransformation::OptimalBlockSize | ( |  | ) | const`[inline, virtual, inherited]`

returns the input block size that is most efficient for this cipher

Note:
  optimal input length is n * OptimalBlockSize() - GetOptimalBlockSizeUsed() for any n > 0

Definition at line 490 of file cryptlib.h.

void StreamTransformation::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length |
| ) |  |  | `[virtual, inherited]`

for ciphers where the last block of data is special, encrypt or decrypt the last block of data

For now the only use of this function is for CBC-CTS mode.

Definition at line 187 of file cryptlib.cpp.

References Algorithm::AlgorithmName(), StreamTransformation::MandatoryBlockSize(), StreamTransformation::MinLastBlockSize(), and StreamTransformation::ProcessData().

The documentation for this class was generated from the following files:

- blumshub.h
- blumshub.cpp